#include "stdafx.h"
#include "queuetp.h"

template <class Type>
QueueTP<Type>::QueueTP() : maxSize(10)
{
	front = rear = NULL;
	qSize = 0;
}
template <class Type>
QueueTP<Type>::QueueTP(int mSize) : maxSize(mSize)
{
	front = rear = NULL;
	qSize = 0;

}
template <class Type>
QueueTP<Type>::~QueueTP()
{
	if(front != NULL)
	{
		while(front != NULL)
		{
			Node * temp = front;
			front = front->next;
			delete temp;
		}
	}
}
template <class Type>
bool QueueTP<Type>::push(Type * n)
{
	if( isfull() )
		return false;

	Node * add = new Node;
	if(add == NULL)
		return false;

	add->next = NULL;
	add->item = n;
	if( isempty() )
	{
		front = rear = add;
		qsize++;
		return true;
	}
	rear->next = add;
	rear = add;
	qsize++;
	return true;
}
template <class Type>
bool QueueTP<Type>::pop(Type * item)
{
	if(isempty() )
		return false;
	Node * temp = front;
	front = front->next;
	delete temp;
	qsize--;
}
template <class Type>
bool QueueTP<Type>::isempty() const
{
	return qsize == 0;

}
template <class Type>
bool QueueTP<Type>::isfull() const
{
	return qsize == maxSize;

}
template <class Type>
int QueueTP<Type>::qCount()
{
	return qsize;
}
template <class Type>
ostream & operator<<(ostream & os, QueueTP<Type> q)
{
	if(q.qsize == 0)
	{
		os<<"Ұ ϴ.\n";
		return os;
	}
	Node* temp;
	for(int i=0; i<qsize; i++)
	{
		temp = front;
		os <<(i+1)<<"°  :"<< temp->item;
		temp = temp->next;
	}
	return os;
}